#!/usr/bin/python

# removeCellBoxes.py is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# removeCellBoxes.py is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with removeCellBoxes.py; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA
#
# Copyright (C) 2007 Naoki ONISHI All rights reserved.

import commands
import os
boxFile = open('box.dat','r')
boxFile.seek(0)
cellSetFile = open('system/cellSetDict.boxes','w')
cellSetFile.write("FoamFile\n{ \n\
    version \t 2.0;\n\
    format \t ascii;\n\n\
    root \t \".\";\n\
    case \t \".\";\n\
    instance \t \"system\";\n\
    local \t \"\";\n\n\
    class \t dictionary;\n\
    object \t cellSetDict;\n\
}\n\n\
name boxes;\n\
action new;\n\
topoSetSources\n\
(\n\
")
line = 0
for line in boxFile:
   (sx,sy,sz,ex,ey,ez)=(0,0,0,0,0,0)
   points = line[:-1].split(' ')
   if len(points) > 1:
#      (sx,sy,sz,ex,ey,ez)=(float(points[0]),float(points[1]),float(points[2]),\
      (sx,sy,sz,ex,ey,ez)=(points[0],points[1],points[2],\
                           points[3],points[4],points[5])
#      cellSetFile.write("boxToCell\n\t{\n\t\
#      box ("+repr(sx)+" "+repr(sy)+" "+repr(sz)+") ("+repr(ex)+" "+repr(ey)+" "+repr(ez)+");\n\t}\n")
      cellSetFile.write("boxToCell\n\t{\n\t\
      box ("+sx+" "+sy+" "+sz+") ("+ex+" "+ey+" "+ez+");\n\t}\n")

cellSetFile.write(");")
invertFile = open('system/cellSetDict.invert','w')
invertFile.write("FoamFile\n{ \n\
    version \t 2.0;\n\
    format \t ascii;\n\n\
    root \t \".\";\n\
    case \t \".\";\n\
    instance \t \"system\";\n\
    local \t \"\";\n\n\
    class \t dictionary;\n\
    object \t cellSetDict;\n\
}\n\n\
name boxes;\n\
action invert;\n\
topoSetSources\n\
(\n);\n\
")

cellSetFile.close()
invertFile.close()

version = os.getenv("WM_PROJECT_VERSION").replace('-', '.').split('.')
if int(version[0]) >= 1 and int(version[1]) >= 5:
   caseArg = ''
else:
   caseArg = ' . .'

commands.getstatusoutput('cp -rf system/cellSetDict.boxes system/cellSetDict')
commands.getstatusoutput('cellSet' + caseArg + ' >> log.cellSet 2>&1 ')
commands.getstatusoutput('cp -rf system/cellSetDict.invert system/cellSetDict')
commands.getstatusoutput('cellSet' + caseArg + ' >> log.cellSet 2>&1 ')
commands.getstatusoutput('subsetMesh' + caseArg + ' boxes >> log.cellSet 2>&1 ')

print "end"
